module ExcludeSet
  (ExcludeSet, exclude, areExcluded, empty)
  where

import Data.Set (Set)
import qualified Data.Set as S

newtype OP a = OP (a, a)
  deriving (Show, Eq, Ord)

inj :: Ord a => a -> a -> OP a
inj x y = OP (min x y, max x y)

newtype ExcludeSet a = ES (Set (OP a))
  deriving Show

exclude :: Ord a => a -> a -> ExcludeSet a -> ExcludeSet a
exclude x y (ES s) = ES (S.insert (inj x y) s)

areExcluded :: Ord a => a -> a -> ExcludeSet a -> Bool
areExcluded x y (ES s) = S.member (inj x y) s

empty :: ExcludeSet a
empty = ES S.empty
